namespace NSeguin.Dev.Web.Common.Data;

public record DarkModeState(bool IsEnabled)
{
    private bool _isEnabled = IsEnabled;

    public event EventHandler<bool>? Changed;

    public bool IsEnabled
    {
        get => _isEnabled;
        set
        {
            if (_isEnabled == value)
            {
                return;
            }

            _isEnabled = value;
            Changed?.Invoke(this, value);
        }
    }

    public void Toggle()
    {
        IsEnabled = !IsEnabled;
    }

    public void Enable()
    {
        IsEnabled = true;
    }

    public void Disable()
    {
        IsEnabled = false;
    }
}